<template>
  <div class="fixed top-0 z-30 w-full header">
    <div class="bg-background3 relative z-[60]">
      <div
        v-loading="isLoading"
        class="container relative mx-auto"
        :class="{ '!w-[1200px]': store.state.selectedThemeName === 'black' }"
      >
        <div class="flex items-center justify-between h-[92px]">
          <nuxt-link
           class="pr-2"
            v-if="!logo.IsHidden"
            :to="logo.HyperLink ? `/${logo.HyperLink}` : '/'"
          >
            <div class="flex justify-start h-[56px] min-w-[168px]">
              <img :src="logo.ImagePath" class="object-contain w-full h-full object-left" />
            </div>
          </nuxt-link>
          <div>
            <div
              class="flex items-center justify-end mt-3 mb-2.5"
              @mouseover="isFeatureContentEnabled = false"
            >
              <div v-if="auth" class="flex items-center">
                <utils-profile-information
                  :referral-enabled="referralEnabled"
                  :is-referral-v2-enabled="isReferralV2Enabled"
                  :username="username"
                  :is-show-deposit-withdrawal="isShowDepositWithdrawal"
                  :is-cash-player="isCashPlayer"
                  :logout="logout"
                />
              </div>
              <div v-if="auth" class="flex items-center">
                <utils-balance-information :is-suspended="isSuspendedAccount" />
                <nuxt-link
                  v-if="isCashPlayer && isShowDepositWithdrawal"
                  to="/deposit"
                  class="px-4 py-1 mx-4 rounded-2xl btn --secondary --textBtn"
                  id="depositBtn"
                >
                  <b class="--textBtn">{{ $t(`deposit${isBhinbhin}`) }}</b>
                </nuxt-link>
              </div>
              <div>
                <nuxt-link
                  v-if="!facebook.IsHidden && facebook.IsHidden !== undefined"
                  :to="facebook.HyperLink"
                  class="cursor-pointer px-4 py-1.5 mr-4 h-7 fb-btn rounded-2xl bg-white border border-[#4857E5] --textBtn flex justify-center items-center relative"
                  target="_blank"
                >
                  <div>
                    <img :src="getAssetImage(`assets/theme/common/icon/facebook.gif`)" class="w-[80px] h-[16px]">
                  </div>
                  <div class="star-icon absolute">
                    <img :src="getAssetImage(`assets/theme/common/icon/star.gif`)" class="w-[24px] h-[24px]">
                  </div>
                </nuxt-link>
              </div>
              <div v-if="!auth" class="flex items-center">
                <nuxt-link
                  to="/login"
                  class="px-4 py-1 mr-4 btn rounded-2xl --secondary --textBtn"
                  id="loginBtn"
                  ><b class="--textBtn">{{ $t("capital_login") }}</b></nuxt-link
                >
                <nuxt-link
                  v-if="!register.IsHidden"
                  to="/register"
                  :id="ID.SIGNUP"
                  class="px-4 py-1 mr-4 rounded-2xl btn --primary --textBtn"
                  ><b class="--textBtn pointer-events-none">{{ $t("joinnow") }}</b></nuxt-link
                >
                <nuxt-link
                  v-if="!agentCooperation.IsHidden"
                  to="/agent-cooperation"
                  class="px-4 py-1 mr-4 btn --tertiary rounded-2xl --textBtn"
                  ><b class="--textBtn">{{ $t("agent_cooperation") }}</b></nuxt-link
                >
              </div>
              <div>
                <utils-language />
              </div>
            </div>
            <ul
              class="flex items-center justify-end capitalize whitespace-nowrap"
            >
              <li
                class="cursor-pointer nav-item --text3"
                @mouseover="isFeatureContentEnabled = false"
                >
                <nuxt-link
                  v-if="!homeTab.IsHidden"
                  class="header-height w-max menu-tab-hover-animated"
                  to="/"
                  :class="[
                    {
                      'active-menu': tabSelected === '/',
                    },
                    { uppercase: isVietnamLangBlackTheme },
                  ]"
                  :id="ID.TAB_TYPE.HOME"
                  ><b class="pointer-events-none">{{ $t("home") }}</b></nuxt-link
                >
              </li>
              <div
                v-for="tab in menuTabHeaders"
                :key="tab"
                class="pl-6 cursor-pointer nav-item --text3"
                @mouseover="productListFeatureHover(tab.TabType, tab.TabURL)"
              >
                <nuxt-link
                  :to="tab.TabURL"
                  :class="[
                    {
                      'active-menu':
                        tabSelected === tab.TabURL?.toLowerCase() ||
                        testActiveGame(tab.TabType, activeTab),
                    },
                    { uppercase: isVietnamLangBlackTheme },
                  ]"
                  class="header-height w-max menu-tab-hover-animated --text3"
                  :id="ID.TAB_TYPE[tab.TabLanguage]"
                >
                  <b class="pointer-events-none">{{ $t(tab.TabLanguage) }}</b>
                </nuxt-link>
              </div>
              <li
                v-if="isAllowPromotionTab"
                class="pl-6 cursor-pointer nav-item --text3"
                @mouseover="isFeatureContentEnabled = false"
              >
                <nuxt-link
                  to="/promotion"
                  :class="[
                    { 'active-menu': tabSelected === '/promotion' },
                    { uppercase: isVietnamLangBlackTheme },
                  ]"
                  class="header-height w-max menu-tab-hover-animated"
                  :id="ID.TAB_TYPE.PROMOTION"
                  ><b class="pointer-events-none">{{ $t("promotion") }}</b></nuxt-link
                >
              </li>
              <li
                v-if="isAppDownloadEnabled"
                class="pl-6 cursor-pointer nav-item --text3"
                @mouseover="isFeatureContentEnabled = false"
              >
                <nuxt-link
                  to="/app-download"
                  :class="{ 'active-menu': tabSelected === '/app-download' }"
                  class="header-height w-max menu-tab-hover-animated"
                  ><b>{{ $t("app_download") }}</b></nuxt-link
                >
              </li>
            </ul>
          </div>
        </div>
      </div>
    </div>
    <product-feature-tab-hover
      v-model:is-feature-hover="isFeatureContentEnabled"
      :component-key="componentKey"
      :feature-products="filterProductFeature"
    />
    <div class="py-2 border-t-2 border-background-4 bg-background1 m-notice">
      <div
        class="container flex items-center mx-auto"
        :class="announcement.IsHidden ? 'justify-end' : ''"
      >
        <utils-announcement
          v-if="!announcement.IsHidden"
          :announcement="announcement.Text"
        />
        <utils-display-time class="text-right" />
      </div>
    </div>
  </div>
  <div class="h-[128px]"></div>
</template>

<script lang="ts">
import { PropType, computed, defineComponent } from "vue";
import { store } from "@/store";
import themePropertyHelper from "@/utils/themePropertyHelper";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";
import {
  useHeaderComponent,
  handleGameEntryOpenWindow,
} from "@/composables/useTheme";
import EnumEntranceLocation from "@/models/enums/enumEntranceLocation";
import commonHelper from "@/utils/commonHelper";
import EnumThemePropertyKey from "~~/models/enums/enumThemePropertyKey";

export default defineComponent({
  name: "Header",
  props: {
    propertyKeys: {
      type: Array as PropType<Array<string>>,
      required: true,
    },
  },
  setup(props) {
    const { getAssetImage, isBhinbhin } = commonHelper;
    const {
      menuTabHeaders,
      tabSelected,
      isLoading,
      filterProductFeature,
      productListFeatureHover,
      isFeatureContentEnabled,
      isAllowPromotionTab,
      referralEnabled,
      agentCooperation,
      register,
      auth,
      isSuspendedAccount,
      isSportLiveEnabled,
      isAppDownloadEnabled,
      username,
      logout,
      isCashPlayer,
      isShowDepositWithdrawal,
      componentKey,
      isReferralV2Enabled,
      homeTab,
    } = useHeaderComponent();
    const route = useRoute();
    const activeTab = computed(() => route.query.tab ?? "");
    const testActiveGame = (tabType: string, activeGame: string): boolean => {
      const temTabType = tabType
        .trim()
        .toLowerCase()
        .replaceAll(" ", "")
        .replaceAll("-", "");
      const temActiveGame = activeGame
        .trim()
        .toLowerCase()
        .replaceAll(" ", "")
        .replaceAll("-", "");
      return temActiveGame === temTabType;
    };
    const properties = computed(() => props.propertyKeys);
    const themeProperties = computed(
      () => store.state.companyThemePropertiesFromApi.ThemeProperties
    );

    const logo = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          properties.value[0]
        )
    );
    const announcement = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          properties.value[1]
        )
    );
    const facebook = computed(() =>
      featuresToggleHelper.getThemePropertyFromApi(
        EnumThemePropertyKey.HtmlId,
        "facebook_link"
      )
    );
    const isVietnamLangBlackTheme = computed(
      () =>
        store.state.locale === "vi_VN" &&
        store.state.selectedThemeName === "black"
    );
    return {
      menuTabHeaders,
      tabSelected,
      isLoading,
      filterProductFeature,
      productListFeatureHover,
      isFeatureContentEnabled,
      isAllowPromotionTab,
      announcement,
      referralEnabled,
      agentCooperation,
      register,
      auth,
      isSuspendedAccount,
      isSportLiveEnabled,
      activeTab,
      testActiveGame,
      logo,
      handleGameEntryOpenWindow,
      EnumEntranceLocation,
      isAppDownloadEnabled,
      getAssetImage,
      isShowDepositWithdrawal,
      isCashPlayer,
      username,
      logout,
      componentKey,
      isVietnamLangBlackTheme,
      store,
      isReferralV2Enabled,
      facebook,
      homeTab,
      isBhinbhin,
    };
  },
});
</script>
<style lang="postcss" scoped>
.bg-header {
  background-color: var(--background3);
}
.header-height {
  height: 40px;
  display: flex;
  align-items: center;
  position: relative;
}
.nav-item .active-menu,
.nav-item:hover .header-height {
  color: var(--selected);
}
.nav-item .active-menu::before,
.nav-item:hover .header-height::before {
  background-color: var(--selected);
  bottom: 0;
  content: "";
  height: 0.125rem;
  left: 0;
  position: absolute;
  width: 100%;
}
.m-notice {
  height: 36px;
}
.fb-btn {
  min-width: 100px;
}
:deep(.star-icon) {
  right: -12px;
}
</style>
